Page MenuHomePhabricator

Explore how to improve highlighting display so it's compatible with Enhanced Recent Changes
Closed, ResolvedPublic

Description

Highlighting doesn't work well with Enhanced Recent Changes. With this preference, when multiple changes for a page exist, only a summary line is shown. Coloring the summary line isn't logical, since different colors might apply to different changes hidden in the page group. So summary lines are currently left unshaded, which means users with this option don't get the full benefit of highlighting.

I think Enhanced Changes is pretty popular. (I heard it's a default on some wikis?) With a modest amount of effort, we could provide improved functionality.

Proposed ideas

Some ideas discussed for now are listed below. I'm sure there are other ideas...

Colored dots
Adding a colored dot in the margin next to the summary line to represent each distinct highlight color applied to a member of the hidden group. This would at least tell users what groups they need to open.

Collapse/Exapand

Add Collapse/Expand buttons at the top of the results page, so that users could expand all the results and scan the coloring. (Also make the Expanded state default.)

Propagate highlight status to the groups

For individual items we can apply the highlight as we do for Recent changes. The complexity seems to be in the grouping elements (those rows with a triangle at the beginning).

For grouping elements we can surface that there are some highlights inside them for the users to expand if interested. When a grouping element contains a highlighted element, the element could be highlighted with:

  • A color if all child items are highlighten in such color. We can consider surfacing blended colors if there are highlights of different colors but that may add also some complexity (since rows can be blended also).
  • In grey if the group contains both highlighted and non-highlighted elements. This will communicate that there are some highlighting elements inside.

An example below:

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 8 2017, 12:48 AM

Coloring the summary line isn't logical, since different colors might apply to different changes hidden in the page group.

I think that problem can be solved. We can use the highlight color when all items in the group are highlighted with such color, and a neutral one (grey) when there are a mix of highlighted and unhighlighted color. Propagating the signal from the items to the group seems logical to me.

You can see more details in the proposal I made in T146291#3080091

Adding a colored dot in the margin next to the summary line to represent each distinct highlight color applied to a member of the hidden group. This would at least tell users what groups they need to open.

We can surface that information, but we need to be careful about distracting from the expand/collapse icon which is the distinctive element of groups for being recognised and the way to access their content.

Add Collapse/Expand buttons at the top of the results page, so that users could expand all the results and scan the coloring. (Also make the Expanded state default.)

Having those controls can be useful, but I'm not convinced on a general expansion by default (since the main purpose of the tool seems to be to group the edits in a more compact way). Another possible approach could be to expand automatically only those groups with highlighted results. As you add new criteria to highlight, some groups will expand to show you they contain some highlighted elements.

Pginer-WMF updated the task description. (Show Details)Mar 20 2017, 12:27 PM

I have feedback on two points:

  • Gray shading will tell users that SOME kind of color is within that group. That's something, but it's of limited value, and not that intuitive. Better would be if a user looking for red would know that there is, in fact, red in that group. I.e., if we showed the dots. You'd probably have to move the little arrow over or something to make room...
  • It looks like you're thinking we can shade the summary line in the event that all the shaded edits in that group are the same color. Agreed. But what about groups for which that uniform color is a blend? Again, showing the dots solves that problem,

It looks like I'm leaning towars a "show the dots" solution. Will that work do you think?

It looks like I'm leaning towars a "show the dots" solution. Will that work do you think?

I see several issues in propagating the dots to the group:

  • It can be misleading in terms of proportion (one highlighted vandalism item in a group of 100 non-highlighted items may give the impression that the whole thing is vandalism) and contradicting dots (getting "minor" and "non-minor" indicators at the same time because some of the contents are of each kind).
  • It increases the signals to process, making it hard to recognise that an element is a group instead of an individual item.

I think we should not asume that users must get absolutely all the info without having to expand a group. Expanding a group to get the details of individual edits is ok. I think our goal should be for highlights inside groups not going unnoticed. For that purpose, signaling that groups have highlights inside seems enough. If we really want to expose all details, it may be better to expand automatically those groups with highlighted elements inside (but only those).

Zache added a subscriber: Zache.Apr 25 2017, 6:16 AM
Zache removed a subscriber: Zache.
Zache added a subscriber: Zache.

@Pginer-WMF, it looks like we're in stalemate here. We should really solve this, though, since we are going to make Enhanced Filters more prominent in the controls.

I don't find the counter-examples you suggest dampen my enthusiasm for just showing the set of all dots in the subgroup. but if you still don't like that, then what if we just included a button at top to open all the sub-groups, so users could see all the highlighting? We could then call it a day.

@Pginer-WMF, it looks like we're in stalemate here. We should really solve this, though, since we are going to make Enhanced Filters more prominent in the controls.

I don't find the counter-examples you suggest dampen my enthusiasm for just showing the set of all dots in the subgroup. but if you still don't like that, then what if we just included a button at top to open all the sub-groups, so users could see all the highlighting? We could then call it a day.

I have been exploring some more options, and I think we can try to surface all dots into the subgroup. One important aspect is to keep the expanding controls (the triangles) in their own column. That is, items that can be expanded have a triangle, and those which cannot be expanded keep an empty space in the same position. In this way we are not mixing circles and triangles, making expandable elements easier to identify when scanning results visually. I created a mockup to illustrate the concept:

I think that looks great. I have to questions/comments:

  • We need to be sure there's room for the maximum number of dots, which would be 5, between the arrow and the page name in summary lines.
  • I see the summary line with yellow and blue dots is colored green. But does coloring the summary lines make sense? I'm imaging that those yellow and blue dots mean that within that group, there is at least one yellow line and one blue line, or possibly one yellow+blue line. I.e., it could be (unlikely but possible) that there would be a line each of each of the 5 colors, but no line that would combine any of them. So in such a circumstance, it seems misleading to me to color the summary line yellow+red+orange+green+blue, since that represents no result that actually exists in the group. Better, I'd think, to make it white. Or maybe light gray?

I think that looks great. I have to questions/comments:

  • We need to be sure there's room for the maximum number of dots, which would be 5, between the arrow and the page name in summary lines.

Yes. I think this is what is done currently with regular highlights. The only difference in this case is that there seems to be already some empty space kept in the "enhanced recent changes" that we can use.

  • I see the summary line with yellow and blue dots is colored green. But does coloring the summary lines make sense? I'm imaging that those yellow and blue dots mean that within that group, there is at least one yellow line and one blue line, or possibly one yellow+blue line. I.e., it could be (unlikely but possible) that there would be a line each of each of the 5 colors, but no line that would combine any of them. So in such a circumstance, it seems misleading to me to color the summary line yellow+red+orange+green+blue, since that represents no result that actually exists in the group. Better, I'd think, to make it white. Or maybe light gray?

I think that showing some highlight on the results make sense to facilitate the scanning. As I mentioned in the ticket description we can use color if (and only if) all items in the group have exactly the same highlight, and use a neutral grey if the sub-items are highlighted in different colors. That is, in the previous example, all items in the blue+yellow group are highlighted both in blue and yellow.

The example below shows how would look the groups (i.e., those lines with a triangle) with more diverse combinations:

The example includes groups highlighted in grey (one group combining members in blue and others with no highlights; and another group combining some blue and some yellow highlights in their members). there is another group highlighted in blue (with all members having one blue highlight) and other groups not highlighted at all (with all their members not highlighted).

jmatazzoni renamed this task from Improve highlighting display so it's compatible with Enhanced Recent Changes to Explore how to improve highlighting display so it's compatible with Enhanced Recent Changes.Jul 17 2017, 6:51 PM
jmatazzoni closed this task as Resolved.Jul 17 2017, 7:32 PM
jmatazzoni claimed this task.